var http = require('http'),
	url = require('url'),
	fs = require('fs'),
	path = require('path'),
	httpProxy = require('http-proxy'),
	log = require('clilog'),
	mime = require('mime'),
	watchr = require('watchr'),
	utils = require('./utils');
//config = require('./config');

function main(configpath) {
	var config = require(configpath);
		console.log(configpath);

	watchr.watch({
		paths: [configpath],
		listeners: {
			error: function(err) {
				log.error('[watch]', err);
			},
			change: function() {
				delete require.cache[configpath];
				config = require(configpath);
				log.info('[watch] reload config:' + configpath);
			}
		}
	});

	http.createServer(function(req, res) {
		var reqUrl = req.url;
		var from = reqUrl;
		var map = config.map;
		if (from) {
			log.info('[get]' + from);
			var to = utils.rewrite(map, from);
			if (from !== to) {
				log.info('[rewirte]' + from + '->' + to);
				if (!/^https?:\/\//.test(to)) {
					var contentType = mime.lookup(to);
					var buffer = fs.readFileSync(to);
					utils.setResponse(res, contentType, buffer);
					return;
				}
				return;
			}
		}
		var parsedUrl = url.parse(reqUrl);
		var proxy = httpProxy.createServer({
			target: {
				host: parsedUrl.hostname,
				port: parsedUrl.port || 80
			}
		});
		proxy.proxyRequest(req, res);

	}).listen(7000, function() {
		console.log('Rewrite Server runing at port: ' + 7000);
	});
}

exports.main = main;